//CCA JasperSoft Copy To Network Share
//copyreports.js
//
//Written by Adnan Hafeezullah
//
//Script that copies reports newly created by CCA 12.8.3 and newer's reporting engine, Jaspersoft.  
//The file(s) are copied to a designated folder (network share) that is specified from DestinationPath.txt

//Script variables
var watcher = require('chokidar'),
    fs = require('fs'),
    path = require('path'),
    CCAServerReportingInstanceDir = path.resolve(__dirname + '\\..') + '\\tomcat\\webapps\\ROOT\\WEB-INF\\JasperInstances'; //C:/Program Files/CA/CCA Server/tomcat/webapps/ROOT/WEB-INF/JasperInstances'; 


//copyfile with callback
function copyFile(source, target, callback) {    
    var rd = fs.createReadStream(source);
    rd.on('error', function(ex) { done('Read ' + ex); });
    var wr = fs.createWriteStream(target + '\\' + path.basename(source), {
        flags: 'w',
        defaultEncoding: 'utf8',
        fd: null,
        autoClose: true
    });
    wr.on('error', function(ex) { done('Write ' + ex); });
    wr.on('finish', done);
    rd.pipe(wr);

    function done(err) { return callback(err) }    
}

//get the destination path form the file
fs.readFile('DestinationReportPath.txt', function(err, NetworkShareDir) {
    //watch the cca reporting instance directory for new files created, copy those files    
    watcher.watch(CCAServerReportingInstanceDir, {
        ignored: /[\/\\]\./,
        persistent: true,
        ignoreInitial: true
    }).on('add', function(file) {
        if (path.basename(file).substring(0,5) != 'swap_') { //cca creates a temp file first that starts with swap_; we dont want to copy that 
            copyFile(file,NetworkShareDir, function(err) {
                if (err) console.log(err)
            })
        }
    }).on('ready', function() {
        console.log('CCA Server Reporting Instance Directory Monitor Enabled For ' + CCAServerReportingInstanceDir + ' and will copy the reports to ' + NetworkShareDir);
    })
 
});